﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PostSharp.Laos;
using System.Diagnostics;
using Logica.Kbn.PostSharpAspect.Exception;

namespace Logica.Kbn.PostSharpAspect
{
    [Serializable()]
    public class NotNullValidationAspect : OnMethodBoundaryAspect
    {
        /// <summary>
        /// Throws exception if the value is null
        /// </summary>
        /// <param name="eventArgs"></param>
        [DebuggerStepThrough()]
        public override void OnEntry(MethodExecutionEventArgs eventArgs)
        {
            //ignore call from reflection
            if (eventArgs.GetReadOnlyArgumentArray() != null)
            {
                //check for null
                if (eventArgs.GetReadOnlyArgumentArray()[0] == null)
                    throw new ValidationException("Value was null.", eventArgs);
            }
            base.OnEntry(eventArgs);
        }


    }
}
